// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// FCGIApp App with all it's children resources
//
// swagger:model FCGIApp
type FCGIApp struct {
	FCGIAppBase `json:",inline"`

	// Acl list
	ACLList Acls `json:"acl_list,omitempty"`
}

// UnmarshalJSON unmarshals this object from a JSON structure
func (m *FCGIApp) UnmarshalJSON(raw []byte) error {
	// AO0
	var aO0 FCGIAppBase
	if err := swag.ReadJSON(raw, &aO0); err != nil {
		return err
	}
	m.FCGIAppBase = aO0

	// AO1
	var dataAO1 struct {
		ACLList Acls `json:"acl_list,omitempty"`
	}
	if err := swag.ReadJSON(raw, &dataAO1); err != nil {
		return err
	}

	m.ACLList = dataAO1.ACLList

	return nil
}

// MarshalJSON marshals this object to a JSON structure
func (m FCGIApp) MarshalJSON() ([]byte, error) {
	_parts := make([][]byte, 0, 2)

	aO0, err := swag.WriteJSON(m.FCGIAppBase)
	if err != nil {
		return nil, err
	}
	_parts = append(_parts, aO0)
	var dataAO1 struct {
		ACLList Acls `json:"acl_list,omitempty"`
	}

	dataAO1.ACLList = m.ACLList

	jsonDataAO1, errAO1 := swag.WriteJSON(dataAO1)
	if errAO1 != nil {
		return nil, errAO1
	}
	_parts = append(_parts, jsonDataAO1)
	return swag.ConcatJSON(_parts...), nil
}

// Validate validates this FCGI app
func (m *FCGIApp) Validate(formats strfmt.Registry) error {
	var res []error

	// validation for a type composition with FCGIAppBase
	if err := m.FCGIAppBase.Validate(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateACLList(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *FCGIApp) validateACLList(formats strfmt.Registry) error {

	if swag.IsZero(m.ACLList) { // not required
		return nil
	}

	if err := m.ACLList.Validate(formats); err != nil {
		if ve, ok := err.(*errors.Validation); ok {
			return ve.ValidateName("acl_list")
		} else if ce, ok := err.(*errors.CompositeError); ok {
			return ce.ValidateName("acl_list")
		}
		return err
	}

	return nil
}

// ContextValidate validate this FCGI app based on the context it is used
func (m *FCGIApp) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	// validation for a type composition with FCGIAppBase
	if err := m.FCGIAppBase.ContextValidate(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateACLList(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *FCGIApp) contextValidateACLList(ctx context.Context, formats strfmt.Registry) error {

	if err := m.ACLList.ContextValidate(ctx, formats); err != nil {
		if ve, ok := err.(*errors.Validation); ok {
			return ve.ValidateName("acl_list")
		} else if ce, ok := err.(*errors.CompositeError); ok {
			return ce.ValidateName("acl_list")
		}
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *FCGIApp) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *FCGIApp) UnmarshalBinary(b []byte) error {
	var res FCGIApp
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
